All Libraries | This Library | Package | Class | Use | Tree | Deprecated | Index | Grand Index | Help
|  | Metadata |
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.sas.metadata.remote
Interface MdOMIUtil

All Superinterfaces:
  java.rmi.Remote

    public interface MdOMIUtil

extends java.rmi.Remote

Used to perform operations against the metadata server, such as querying and deleting objects. This interface wraps the methods available in the IOMI interface.

To retrieve the instance of this interface, see: `MdFactory.getOMIUtil()`

This class depends on objects being contained in an `object store`. A connection to the metadata server must be established first before using any of the methods on this interface. To create a connection, use `MdOMRConnection`.

Since:
  9.0
See Also:
  `com.sas.metadata.remote`

Field Summary
`static java.lang.String` | `CLASSID_FTP` The class ID for a FTP server: CBA26437-1577-4FF8-93F6-9B68B4DD8D2E
`static java.lang.String` | `CLASSID_HTTP` The Class ID for a HTTP server: DAC0D7F0-10DA-11D6-8816- AA0004006D06
`static java.lang.String` | `CLASSID_MESSAGEQUEUE_JMS` The class ID for a JMS Message Queue Manager: "MessageQueue.JMS"
`static java.lang.String` | `CLASSID_MESSAGEQUEUE_MS` The class ID for a Message Queue: "MessageQueue.MSMQ"
`static java.lang.String` | `CLASSID_MESSAGEQUEUE_WEBSPHERE` The class ID for a Message Queue: "MessageQueue.Websphere"
`static java.lang.String` | `CLSID_SAS_POOLED_WORKSPACE` The class ID for a Pooled Workspace Server: 620963ee-32bf-4128-bf5f-4b0df8ff90eb
`static java.lang.String` | `CLSID_SAS_WORKSPACE` The class id of the classic SAS server: 440196d4-90f0-11d0-9f41-00a024bb830c
`static java.lang.String` | `CLSID_SASGMS_GMS` The class id of the generic server: 9c186a64-83e4-11d2-b956-00c04f81993c
`static java.lang.String` | `CLSID_SASMDX_SERVER` The class id of OLAP V9: f3f46472-1e31-11d5-87c2-00c04f38f9f6
`static java.lang.String` | `CLSID_SASMQX_MQX` the class id of the message queue server: 8d9ef489-8d1e-11d2-b94f-00c04f8198c0
`static java.lang.String` | `CLSID_SASOMI_OMI` The class id of the OMR server: 2887e7d7-4780-11d4-879f-00c04f38f0db
`static java.lang.String` | `CLSID_SASSTP_STOREDPROCESSSERVER` The class id of SAS/Intrnet V9: 15931e31-667f-11d5-8804-00c04f35ac8c
`static java.lang.String` | `FOLDERTYPE_APPDATA` The user's application data folder
`static java.lang.String` | `FOLDERTYPE_HOME` The user's home folder
`static java.lang.String` | `FOLDERTYPE_MYFOLDER` The user's "my folder"
`static int` | `OMI_ALL` (1) specifies that the method get all of the properties of the requested object.
`static int` | `OMI_ALL_DESCENDANTS` (64) Returns all subtypes along with all of their descendants
`static int` | `OMI_ALL_SIMPLE` (8) specifies that the method get all of the attributes of the requested object.
`static int` | `OMI_CI_DELETE_ALL` Deprecated. As of 9.2, no longer supported by the metadata server
`static int` | `OMI_CI_NODELETE` Deprecated. As of 9.2, no longer supported by the metadata server
`static int` | `OMI_CLIENT_ID` (8388608) Client is supplying repository ID on AddMetadata of REPOS.
`static int` | `OMI_DELETE` (32) Deletes the files in a repository in addition to the repository registration.
`static int` | `OMI_DEPENDENCY_USEDBY` (16384) In GetMetadata, specifies to look for cross-repository references in repositories that use the current repository.
`static int` | `OMI_DEPENDENCY_USES` (8192) Specifies to retrieve objects of the passed type from all repositories that have a DependencyUses dependency
`static int` | `OMI_EXPAND` Deprecated. no longer supported by the metadata server
`static int` | `OMI_FULL_OBJECT` (2) Instructs the SAS Metadata Server to use a public object type definition from the Object Type Dictionary to expand the specified object's logical metadata definition.
`static int` | `OMI_GET_ID` Deprecated.
`static int` | `OMI_GET_METADATA` (256) Specifies to execute a GetMetadata call for each object that is returned by the GetMetadataObjects request.
`static int` | `OMI_GET_OBJREF` (4096)
`static int` | `OMI_IGNORE_NOTFOUND` (134217728) This flag is for DeleteMetadata to tell it to ignore objects not found so that it will not return on error.
`static int` | `OMI_INCLUDE_SUBTYPES` (16) Specifies to retrieve metadata objects that are subtypes of the passed metadata type in addition to objects of the passed type.
`static int` | `OMI_LOCK` (32768) Locks the specified object and any associated objects selected by GetMetadata flags and options from update by other users.
`static int` | `OMI_LOCK_TEMPLATE` Deprecated. As of 9.2, no longer supported by the metadata server
`static int` | `OMI_MATCH_CASE` (512) Specifies to perform a case-sensitive search of the criteria specified in the option.
`static int` | `OMI_MULT_REQUEST` (1073741824)
`static int` | `OMI_NOFORMAT` (67108864) Do not format time values returned from the server.
`static int` | `OMI_PURGE` Deprecated. As of 9.2, no longer supported by the metadata server
`static int` | `OMI_REINIT` (2097152) Deletes the contents of a repository but does not remove the repository's registration from the repository manager.
`static int` | `OMI_RETURN_LIST` (1024) Returns a list of deleted object IDs, as well as any cascading object IDs that were deleted.
`static int` | `OMI_SUCCINCT` (2048) specifies to omit properties that do not contain values or that contain null values.
`static int` | `OMI_TEMPLATE` (4) checks the Options parameter for one or more user-defined templates that specify the properties to return for a given metadata type.
`static int` | `OMI_TRUNCATE` (4194304) Deletes all metadata objects but does not remove the metadata object containers from a repository or change the repository's registration.
`static int` | `OMI_TRUSTED_CLIENT` (268435456)Determines if the client can call this method.
`static int` | `OMI_UNLOCK` (131072) Unlocks the specified object and any associated objects that were locked when the update is completed
`static int` | `OMI_UNLOCK_FORCE` (262144) Unlocks any locks held by another user so that a metadata object can be updated.
`static int` | `OMI_XMLSELECT` (128) Checks the Options parameter for criteria to qualify the objects that are returned by the server.

Method Summary
`int` | `addMetadata(java.lang.String inXML, java.lang.String reposID, org.omg.CORBA.StringHolder outXML, int iFlags)` Performs an add operation against the metadata server.
`org.w3c.dom.Document` | `ApplyXML(java.lang.String inXML, java.lang.String reposID)` This routine is used by metadata importers to filter their XML to handle XML updates.
`java.lang.String` | `cleanStringForXML(java.lang.String s)` cleanStringForXML takes a String and converts "bad" characters, like \n and others, into acceptable &#xxx entities.
`java.lang.String` | `createGetXMLString(java.util.Map<java.lang.String,java.lang.String> objectMap)` Creates and returns the XML string used for a GetMetadata request.
`java.lang.String` | `createGetXMLString(java.lang.String strType, java.lang.String strFQID, java.util.List<java.lang.String> simpleAttr, java.util.List<java.lang.String> complexAttr)` Creates and returns the XML string to retrieve simple and/or complex attributes.
`java.lang.String` | `createObjectAttributeString(java.util.Map<java.lang.String,java.lang.String> attributes)` Creates a string of an object's attributes as key/value pairs
`java.lang.String` | `createRefreshXML(CMetadata meta, boolean refreshAssocsSetByServerOnly, boolean refreshAll)` Creates an XML string used for refreshing an object.
`java.lang.String` | `createUpdateXMLSimple(java.lang.String strType, java.lang.String strFQID, java.util.List<java.lang.String> attributes, java.util.List<java.lang.String> values)` Creates and returns the XML string of the passed in attributes
`java.lang.String` | `createXMLSubString(java.util.List<java.lang.String> attributes, java.util.List<java.lang.String> values)` Creates and returns the XML string of the passed in attributes
`java.util.List<java.lang.String>` | `deleteMetadataObject(CMetadata inObject)` Delete a CMetadata object and all it's dependancies.
`java.util.List<java.lang.String>` | `deleteMetadataObject(CMetadata metadataObject, java.lang.String template)` Deletes an object from the server using the specified delete template.
`java.util.List<java.lang.String>` | `deleteMetadataObject(java.lang.String objectType, java.lang.String objectID)` Deletes a metadata object and all of its dependencies
`java.util.List<java.lang.String>` | `deleteMetadataObject(java.lang.String objectType, java.lang.String objectID, java.lang.String template)` Deletes a metadata object and all of its dependencies
`java.util.List<java.lang.String>` | `deleteMetadataObjects(java.util.List<? extends CMetadata> inObjects)` Delete a CMetadata object and all it's dependancies.
`java.util.List<java.lang.String>` | `deleteMetadataObjects(java.util.Map<java.lang.String,java.lang.String> inObjects)` Delete multiple objects from the server and all their dependencies.
`int` | `doesObjectExist(java.lang.String reposID, java.lang.String objectType, java.lang.String xmlSelect)` Returns whether an object exists on the metadata server.
`org.w3c.dom.Document` | `DoRequest(java.lang.String inXML)` Performs a DoRequest
`org.w3c.dom.Document` | `DoRequest(java.lang.String inXML, boolean fUpdateIds)` Performs a DoRequest
`void` | `DoRequestNoReturn(java.lang.String inXML, boolean fUpdateIds)` Performs a DoRequest
`CMetadata` | `doSimple(CMetadata thisObject, org.w3c.dom.NamedNodeMap thisNodeMap)` Calls 'set' methods for given object for nodes in given NodeMap
`java.lang.String` | `formatXML(java.lang.String original)` Format the XML so that we can read it easier.
`CMetadata` | `getAssociatedObject(CMetadata object, java.lang.String strAssociation, java.lang.String strTemplate)` Get the single metatdata object from the given associtation.
`CMetadata` | `getAssociatedObject(CMetadata object, java.lang.String strAssociation, java.lang.String strTemplate, boolean doNotOverrideAssocs)` Get the single metatdata object from the given associtation.
`AssociationList` | `getAssociatedObjects(CMetadata object, java.lang.String strAssociation, java.lang.String strTemplate)` Gets the list of metatdata objects for the given association.
`AssociationList` | `getAssociatedObjects(CMetadata object, java.lang.String strAssociation, java.lang.String strTemplate, boolean doNotOverrideAssocs)` Gets the list of metatdata objects for the given association.
`java.lang.String` | `getAttribute(java.lang.String strAttribute, org.w3c.dom.NamedNodeMap childNodeMap)` Retrieve the requested attribute from the XML dom object.
`java.lang.String` | `getFoundationReposID()` Returns the ID of the Foundation repository
`CMetadata` | `getFoundationRepository()` Returns the foundation repository for the connected metadata server.
`CMetadata` | `getFullObject(MdObjectStore store, CMetadata meta)` Performs a GetMetadata request on an existing public object.
`CMetadata` | `getFullObject(MdObjectStore store, java.lang.String objectType, java.lang.String objectID)` Performs a GetMetadata request on an existing public object.
`java.util.List` | `getFullObjects(MdObjectStore store, java.util.Map<java.lang.String,java.lang.String> objectMap)` Performs a GetMetadata request on a set of existing public objecst.
`Identity` | `getIdentity(MdObjectStore store)` This routine is used to retrieve the identity object of the current user.
`java.util.List` | `getMetadata(MdStore store, java.util.Map objectMap, java.lang.String template, int flags)` Performs a GetMetadata request for a group of objects.
`java.util.List` | `getMetadata(MdStore store, java.util.Map objectMap, java.lang.String template, int flags, boolean doNotOverrideAssocs, boolean doNotOverrideAttrs)` Performs a GetMetadata request for a group of objects.
`org.w3c.dom.Document` | `getMetadata(java.lang.String inXML, int iFlags)` Sends input XML string to metadata server, and parses the output XML into a DOM document.
`org.w3c.dom.Document` | `getMetadata(java.lang.String inXML, java.lang.String strTemplate, int iFlags)` Sends input and template XML strings to metadata server, and parses the output XML into a DOM document.
`CMetadata` | `getMetadataAllDepths(CMetadata object, java.util.List<java.lang.String> inSimpleAttr, java.util.List<java.lang.String> inComplexObject, java.lang.String strTemplate, int iOptions)` This method constructs CMetadata objects and sets both simple and complex attributes.
`CMetadata` | `getMetadataAllDepths(CMetadata object, java.util.List<java.lang.String> inSimpleAttr, java.util.List<java.lang.String> inComplexObject, java.lang.String strTemplate, int iOptions, boolean doNotOverrideAssocs)` This method constructs CMetadata objects and sets both simple and complex attributes.
`CMetadata` | `getMetadataAllDepths(MdStore inStore, java.lang.String strType, java.lang.String strFQID, java.util.List<java.lang.String> inSimpleAttr, java.util.List<java.lang.String> inComplexObject, java.lang.String strTemplate, int iOptions)` This method constructs CMetadata objects and sets both simple and complex attributes.
`CMetadata` | `getMetadataAllDepths(MdStore inStore, java.lang.String strType, java.lang.String strFQID, java.util.List<java.lang.String> inSimpleAttr, java.util.List<java.lang.String> inComplexObject, java.lang.String strTemplate, int iOptions, boolean doNotOverrideAssocs)` This method constructs CMetadata objects and sets both simple and complex attributes.
`java.util.List` | `getMetadataNoCache(java.util.Map objectMap, java.lang.String strOptions, int iFlags)` Performs a GetMetadata request against the server.
`java.util.Map` | `getMetadataNoCache(java.lang.String strType, java.lang.String strFQID, java.lang.String strOptions, int iFlags)` Performs a GetMetadata request against the server.
`java.util.List` | `getMetadataObjects(MdStore inStore, java.lang.String inXML, java.lang.String strTemplate, int iFlags)` Sends input and template XML strings to metadata server, and parses the output XML into a List of objects contained in the inStore.
`java.util.List` | `getMetadataObjects(MdStore inStore, java.lang.String inXML, java.lang.String strTemplate, int iFlags, boolean doNotOverrideAssocs)` Sends input and template XML strings to metadata server, and parses the output XML into a List of objects contained in the inStore.
`java.util.List` | `getMetadataObjects(java.lang.String strReposID, java.lang.String strType)` Gets the list of metatdata objects in the repository for the requested type.
`java.util.List` | `getMetadataObjects(java.lang.String strReposID, java.lang.String strType, int iFlags)` Gets the list of metatdata objects in the repository for the requested type.
`java.util.List` | `getMetadataObjects(java.lang.String strReposID, java.lang.String strType, int flags, java.lang.String strOptions)` Gets the list of metatdata objects in the repository for the requested type.
`java.util.List` | `getMetadataObjectsNoCache(java.lang.String strType, java.lang.String strReposId, java.lang.String strOptions, int iFlags)` Performs a GetMetadataObjects request against the server.
`java.util.List` | `getMetadataObjectsSubset(MdStore inStore, java.lang.String strReposID, java.lang.String strType, int flags, java.lang.String options)` Gets the list of metatdata objects in the repository for the requested type.
`java.util.List` | `getMetadataObjectsSubset(MdStore inStore, java.lang.String strReposID, java.lang.String strType, int flags, java.lang.String options, boolean doOverrideAssocs)` Gets the list of metatdata objects in the repository for the requested type.
`java.util.List` | `getMetadataObjectsSubsetList(MdStore inStore, java.lang.String strReposID, java.lang.String strType, int flags, java.lang.String options, boolean doOverrideAssocs)` Gets the list of metatdata objects in the repository for the requested type.
`java.util.List<java.lang.String>` | `getMetadataSimple(java.lang.String strType, java.lang.String strFQID, java.util.List<java.lang.String> attributes)` Returns a List of the simple attributes requested; these objects have been parsed and are returned as Strings in the order they were requested
`java.lang.String` | `getMetadataSimple(java.lang.String strType, java.lang.String strFQID, java.lang.String attributeName)` Returns a single attribute value from the server.
`java.lang.String` | `getNamespace()` Returns the current namespace used for OMI interactions
`java.lang.String` | `getObjectPath(MdObjectStore store, PrimaryType meta, boolean includeType)` Returns the path of the specified public object.
`java.lang.String` | `getReposIdFromMetadataObject(CMetadata meta)` Returns the fully qualified repository id for a given metadata object (A0000001.XXXXXXXX).
`java.util.List<CMetadata>` | `getRepositories()` Reads all repositories registered in the Common Metadata Repository Manager.
`ResponsibleParty` | `getResponsibleParty(MdObjectStore store, java.lang.String identityName, java.lang.String responsibility)` Returns a responsible party object for a given identity and responsibility.
`ResponsibleParty` | `getResponsibleParty(MdObjectStore store, java.lang.String identityName, java.lang.String responsibility, java.lang.String template, int flags)` Returns a responsible party object for a given identity and responsibility.
`java.util.List<java.lang.String>` | `getSubTypes(java.lang.String objectType, boolean includeDescendants)` Gets the subtypes specific metadata object type.
`void` | `getTypeProperties(java.lang.String objectType, java.util.Map<java.lang.String,java.util.Map<java.lang.String,java.lang.String>> attributeMap, java.util.Map<java.lang.String,java.util.Map<java.lang.String,java.lang.String>> associationMap)` Gets the properties for a specific metadata object type.
`void` | `getTypes(java.util.List<java.lang.String> nameList, java.util.List<java.lang.String> descList)` Gets the types that are available in the repository.
`Tree` | `getUserHomeFolder(MdObjectStore store, java.lang.String userName, java.lang.String folderName, java.lang.String template, int flags)` Returns a home folder for a given user.
`Tree` | `getUserHomeFolder(MdObjectStore store, java.lang.String userName, java.lang.String folderName, java.lang.String template, int flags, boolean createIfNecessary)` Returns a home folder for a given user.
`java.lang.String` | `getUserHomeFolderName(java.lang.String userName, java.lang.String folderName)` Returns the localized name of a user's home folder.
`org.w3c.dom.Document` | `parseXML(java.lang.String strXML)` routine to parse a passed in xml string and return a dom document
`org.w3c.dom.Document` | `parseXML(java.net.URL xmlDocument)` routine to parse a passed in xml URL and return a dom document
`CMetadata` | `populateObject(CMetadata metaObject, org.w3c.dom.NamedNodeMap simpleNodeMap, org.w3c.dom.NodeList complexNodeList)` Populates an objects simple and complex attributes, by what is in the simpleNodeMap and the complexNodeList.
`CMetadata` | `populateObject(CMetadata metaObject, org.w3c.dom.NamedNodeMap simpleNodeMap, org.w3c.dom.NodeList complexNodeList, boolean doNotOverrideAssocs)` Populates an objects simple and complex attributes, by what is in the simpleNodeMap and the complexNodeList.
`java.util.List` | `populateObjects(CMetadata metaObject, org.w3c.dom.NamedNodeMap simpleNodeMap, org.w3c.dom.NodeList complexNodeList, boolean doNotOverrideAssocs, java.util.List objects)` Populates an objects simple and complex attributes, by what is in the simpleNodeMap and the complexNodeList.
`void` | `populateStoreFromInputStream(MdStore inStore, java.io.InputStream stream, int state, boolean useReposForNewObjects)` Build objects from an input stream and set states to desired state.
`void` | `populateStoreFromString(MdStore inStore, org.w3c.dom.Document doc, int state, boolean useReposForNewObjects)` Build objects from source XML and set states to desired state.
`void` | `populateStoreFromString(MdStore inStore, java.lang.String inXML, int state, boolean useReposForNewObjects)` Build objects from source XML and set states to desired state.
`void` | `processDeletedObjects(org.w3c.dom.Document outDoc)` This deletes objects on the client that have been deleted from the server and are returned from a DeltedObjects array.
`void` | `setNamespace(java.lang.String newNamespace)` Sets the current namespace used for OMI interactions
`void` | `setObjectAssociations(CMetadata metaObject, java.util.List outComplexNames, java.util.List[] outComplexObjects, boolean doNotOverrideAssns)` Call given object's 'set...s' methods for the given complex attributes
`void` | `updateMetadata(java.lang.String inXML)`
`int` | `updateMetadata(java.lang.String inXML, org.omg.CORBA.StringHolder outXML, int iFlags)` Performs an update operation against the metadata server.
`void` | `updateMetadataSimple(java.lang.String inXML)`
`void` | `updateMetadataSimple(java.lang.String strType, java.lang.String strFQID, java.util.List<java.lang.String> attributes, java.util.List<java.lang.String> values)` Updates the values of the simple attributes given.
`void` | `updateObjectId(org.w3c.dom.Document inDoc, org.w3c.dom.Document outDoc)` Updates the object ids on the local server stores to reflect the new id on the server.

Field Detail

### FOLDERTYPE_HOME

    static final java.lang.String FOLDERTYPE_HOME

  The user's home folder

  See Also:
    Constant Field Values

### FOLDERTYPE_MYFOLDER

    static final java.lang.String FOLDERTYPE_MYFOLDER

  The user's "my folder"

  See Also:
    Constant Field Values

### FOLDERTYPE_APPDATA

    static final java.lang.String FOLDERTYPE_APPDATA

  The user's application data folder

  See Also:
    Constant Field Values

### OMI_ALL

    static final int OMI_ALL

  (1) specifies that the method get all of the properties of the requested object. If the XML stream returns a reference to any associated objects, then the method will return only general, identifying information for the associated objects.

  See Also:
    Constant Field Values

### OMI_EXPAND

    static final int OMI_EXPAND

  Deprecated. no longer supported by the metadata server
  (2) specifies that references to associated objects be expanded to return all of the properties of each associated object. This flag is typically used with the OMI_ALL flag to return all of the properties of associated objects in addition to those of the requested object. Refer to the SAS Namespace Types documentation to determine which associations can be expanded.

  See Also:
    Constant Field Values

### OMI_FULL_OBJECT

    static final int OMI_FULL_OBJECT

  (2) Instructs the SAS Metadata Server to use a public object type definition from the Object Type Dictionary to expand the specified object's logical metadata definition.

  See Also:
    Constant Field Values

### OMI_TEMPLATE

    static final int OMI_TEMPLATE

  (4) checks the Options parameter for one or more user-defined templates that specify the properties to return for a given metadata type. The templates are passed in a element in the Options parameter.

  See Also:
    Constant Field Values

### OMI_ALL_SIMPLE

    static final int OMI_ALL_SIMPLE

  (8) specifies that the method get all of the attributes of the requested object.

  See Also:
    Constant Field Values

### OMI_INCLUDE_SUBTYPES

    static final int OMI_INCLUDE_SUBTYPES

  (16) Specifies to retrieve metadata objects that are subtypes of the passed metadata type in addition to objects of the passed type. If OMI_XMLSELECT is also specified, it will affect the metadata and subtypes that are retrieved.

  See Also:
    Constant Field Values

### OMI_DELETE

    static final int OMI_DELETE

  (32) Deletes the files in a repository in addition to the repository registration. This flag is reserved for the Repository Administrator and works only in the REPOS namespace on the RepositoryBase type

  See Also:
    Constant Field Values

### OMI_CI_DELETE_ALL

    static final int OMI_CI_DELETE_ALL

  Deprecated. As of 9.2, no longer supported by the metadata server
  (33) Deletes fetched as well as checked and new metadata objects from a project repository upon check in to a primary repository

  See Also:
    Constant Field Values

### OMI_ALL_DESCENDANTS

    static final int OMI_ALL_DESCENDANTS

  (64) Returns all subtypes along with all of their descendants

  See Also:
    Constant Field Values

### OMI_XMLSELECT

    static final int OMI_XMLSELECT

  (128) Checks the Options parameter for criteria to qualify the objects that are returned by the server. The criteria are specified in a search string that is passed in the option. See Using the OMI_XMLSelect Option for more information.

  See Also:
    Constant Field Values

### OMI_GET_METADATA

    static final int OMI_GET_METADATA

  (256) Specifies to execute a GetMetadata call for each object that is returned by the GetMetadataObjects request. See Using the OMI_GET_METADATA Flag for more information.

  See Also:
    Constant Field Values

### OMI_MATCH_CASE

    static final int OMI_MATCH_CASE

  (512) Specifies to perform a case-sensitive search of the criteria specified in the option. The OMI_MATCH_CASE flag cannot be used without the OMI_XMLSELECT flag.

  See Also:
    Constant Field Values

### OMI_RETURN_LIST

    static final int OMI_RETURN_LIST

  (1024) Returns a list of deleted object IDs, as well as any cascading object IDs that were deleted.

  See Also:
    Constant Field Values

### OMI_SUCCINCT

    static final int OMI_SUCCINCT

  (2048) specifies to omit properties that do not contain values or that contain null values.

  See Also:
    Constant Field Values

### OMI_GET_OBJREF

    static final int OMI_GET_OBJREF

  (4096)

  See Also:
    Constant Field Values

### OMI_DEPENDENCY_USES

    static final int OMI_DEPENDENCY_USES

  (8192) Specifies to retrieve objects of the passed type from all repositories that have a DependencyUses dependency

  See Also:
    Constant Field Values

### OMI_DEPENDENCY_USEDBY

    static final int OMI_DEPENDENCY_USEDBY

  (16384) In GetMetadata, specifies to look for cross-repository references in repositories that use the current repository. In GetMetadataObjects, specifies to retrieve objects of the passed type from all repositories that have a DependencyUsedBy dependency.

  See Also:
    Constant Field Values

### OMI_LOCK

    static final int OMI_LOCK

  (32768) Locks the specified object and any associated objects selected by GetMetadata flags and options from update by other users.

  See Also:
    Constant Field Values

### OMI_LOCK_TEMPLATE

    static final int OMI_LOCK_TEMPLATE

  Deprecated. As of 9.2, no longer supported by the metadata server
  (65536) In GetMetadata, specifies to lock the associated objects specified in a user-defined lock template instead of associated objects requested by the method. In the other methods, overrides the default OMA lock template with a user-supplied template. In all cases, the user-defined lock template is submitted in a element in the Options parameter.

  See Also:
    Constant Field Values

### OMI_UNLOCK

    static final int OMI_UNLOCK

  (131072) Unlocks the specified object and any associated objects that were locked when the update is completed

  See Also:
    Constant Field Values

### OMI_UNLOCK_FORCE

    static final int OMI_UNLOCK_FORCE

  (262144) Unlocks any locks held by another user so that a metadata object can be updated.

  See Also:
    Constant Field Values

### OMI_CI_NODELETE

    static final int OMI_CI_NODELETE

  Deprecated. As of 9.2, no longer supported by the metadata server
  (524288) Keeps copies of checked, fetched, and new metadata objects in a project repository after check in to a primary repository.

  See Also:
    Constant Field Values

### OMI_PURGE

    static final int OMI_PURGE

  Deprecated. As of 9.2, no longer supported by the metadata server
  (1048576) Removes previously deleted metadata from a repository without disturbing the current metadata objects.

  See Also:
    Constant Field Values

### OMI_REINIT

    static final int OMI_REINIT

  (2097152) Deletes the contents of a repository but does not remove the repository's registration from the repository manager.

  See Also:
    Constant Field Values

### OMI_TRUNCATE

    static final int OMI_TRUNCATE

  (4194304) Deletes all metadata objects but does not remove the metadata object containers from a repository or change the repository's registration.

  See Also:
    Constant Field Values

### OMI_CLIENT_ID

    static final int OMI_CLIENT_ID

  (8388608) Client is supplying repository ID on AddMetadata of REPOS.

  See Also:
    Constant Field Values

### OMI_NOFORMAT

    static final int OMI_NOFORMAT

  (67108864) Do not format time values returned from the server.

  See Also:
    Constant Field Values

### OMI_IGNORE_NOTFOUND

    static final int OMI_IGNORE_NOTFOUND

  (134217728) This flag is for DeleteMetadata to tell it to ignore objects not found so that it will not return on error.

  See Also:
    Constant Field Values

### OMI_TRUSTED_CLIENT

    static final int OMI_TRUSTED_CLIENT

  (268435456)Determines if the client can call this method. This flag is currently required.

  See Also:
    Constant Field Values

### OMI_GET_ID

    static final int OMI_GET_ID

  Deprecated.
  (536870912) This flag is reserved for SAS usage only. It requests a list of new object Ids from the server to be used by the client. The OMI_GET_ID flag cannot be used without the OMI_TRUSTED_CLIENT flag. The number of requested Ids is specified in the option.

  See Also:
    Constant Field Values

### OMI_MULT_REQUEST

    static final int OMI_MULT_REQUEST

  (1073741824)

  See Also:
    Constant Field Values

### CLSID_SAS_WORKSPACE

    static final java.lang.String CLSID_SAS_WORKSPACE

  The class id of the classic SAS server: 440196d4-90f0-11d0-9f41-00a024bb830c

  See Also:
    Constant Field Values

### CLSID_SASSTP_STOREDPROCESSSERVER

    static final java.lang.String CLSID_SASSTP_STOREDPROCESSSERVER

  The class id of SAS/Intrnet V9: 15931e31-667f-11d5-8804-00c04f35ac8c

  See Also:
    Constant Field Values

### CLSID_SASOMI_OMI

    static final java.lang.String CLSID_SASOMI_OMI

  The class id of the OMR server: 2887e7d7-4780-11d4-879f-00c04f38f0db

  See Also:
    Constant Field Values

### CLSID_SASMDX_SERVER

    static final java.lang.String CLSID_SASMDX_SERVER

  The class id of OLAP V9: f3f46472-1e31-11d5-87c2-00c04f38f9f6

  See Also:
    Constant Field Values

### CLSID_SASGMS_GMS

    static final java.lang.String CLSID_SASGMS_GMS

  The class id of the generic server: 9c186a64-83e4-11d2-b956-00c04f81993c

  See Also:
    Constant Field Values

### CLSID_SASMQX_MQX

    static final java.lang.String CLSID_SASMQX_MQX

  the class id of the message queue server: 8d9ef489-8d1e-11d2-b94f-00c04f8198c0

  See Also:
    Constant Field Values

### CLASSID_HTTP

    static final java.lang.String CLASSID_HTTP

  The Class ID for a HTTP server: DAC0D7F0-10DA-11D6-8816- AA0004006D06

  See Also:
    Constant Field Values

### CLASSID_FTP

    static final java.lang.String CLASSID_FTP

  The class ID for a FTP server: CBA26437-1577-4FF8-93F6-9B68B4DD8D2E

  See Also:
    Constant Field Values

### CLASSID_MESSAGEQUEUE_MS

    static final java.lang.String CLASSID_MESSAGEQUEUE_MS

  The class ID for a Message Queue: "MessageQueue.MSMQ"

  See Also:
    Constant Field Values

### CLASSID_MESSAGEQUEUE_WEBSPHERE

    static final java.lang.String CLASSID_MESSAGEQUEUE_WEBSPHERE

  The class ID for a Message Queue: "MessageQueue.Websphere"

  See Also:
    Constant Field Values

### CLSID_SAS_POOLED_WORKSPACE

    static final java.lang.String CLSID_SAS_POOLED_WORKSPACE

  The class ID for a Pooled Workspace Server: 620963ee-32bf-4128-bf5f-4b0df8ff90eb

  See Also:
    Constant Field Values

### CLASSID_MESSAGEQUEUE_JMS

    static final java.lang.String CLASSID_MESSAGEQUEUE_JMS

  The class ID for a JMS Message Queue Manager: "MessageQueue.JMS"

  See Also:
    Constant Field Values

Method Detail

### getNamespace

    java.lang.String getNamespace()
                                  throws java.rmi.RemoteException

  Returns the current namespace used for OMI interactions

  Returns:
    The name space currently used for OMI calls
  Throws:
    `java.rmi.RemoteException`

### setNamespace

    void setNamespace(java.lang.String newNamespace)
                      throws java.rmi.RemoteException

  Sets the current namespace used for OMI interactions

  Parameters:
    `newNamespace` - String
  Throws:
    `java.rmi.RemoteException`

### getReposIdFromMetadataObject

    java.lang.String getReposIdFromMetadataObject(CMetadata meta)
                                                  throws java.rmi.RemoteException

  Returns the fully qualified repository id for a given metadata object (A0000001.XXXXXXXX). An empty string is returned if the object does not exist.

  Parameters:
    `meta` - the metadata object
  Returns:
    the repository id for this object
  Throws:
    `java.rmi.RemoteException`

### getFoundationRepository

    CMetadata getFoundationRepository()
                                      throws MdException,
                                             java.rmi.RemoteException

  Returns the foundation repository for the connected metadata server. A `CMetadata` object is returned. If a foundation repository cannot be found, a null is returned.

  Returns:
    the foundation repository as a CMetadata object
  Throws:
    `MdException`
    `java.rmi.RemoteException`

### getRepositories

    java.util.List<CMetadata> getRepositories()
                                              throws MdException,
                                                     java.rmi.RemoteException

  Reads all repositories registered in the Common Metadata Repository Manager.

  Returns:
    List of CMetadata objects representing the repositories.
  Throws:
    `MdException` - in the case of any server errors
    `java.rmi.RemoteException`

### getFullObject

    CMetadata getFullObject(MdObjectStore store,
                            CMetadata meta)
                            throws MdException,
                                   java.rmi.RemoteException

  Performs a GetMetadata request on an existing public object. A public object is defined as an object that has its PublicType attribute set with a matching entry in the type dictionary.

  This method is mainly a convenience method for retrieving the full metadata representation of a public object, without requiring you to know which associations need to be passed in via a template. All information for the public object, including all of its attributes as well as all of its subordinate objects will be retrieved. The method does not require any flags or templates to be passed in as they (`OMI_FULL_OBJECT`, `OMI_ALL_SIMPLE`, and `OMI_SUCCINCT`) are automatically passed to the server for you.

  Note: this method will always overwrite any attributes and associations that may already be set on the object.

  Parameters:
    `store` - the store to create the object(s) in
    `meta` - the metadata object to query
  Returns:
    the metadata object
  Throws:
    `MdException`
    `java.rmi.RemoteException`

### getFullObject

    CMetadata getFullObject(MdObjectStore store,
                            java.lang.String objectType,
                            java.lang.String objectID)
                            throws MdException,
                                   java.rmi.RemoteException

  Performs a GetMetadata request on an existing public object. A public object is defined as an object that has its PublicType attribute set with a matching entry in the type dictionary.

  This method is mainly a convenience method for retrieving the full metadata representation of a public object, without requiring you to know which associations need to be passed in via a template. All information for the public object, including all of its attributes as well as all of its subordinate objects will be retrieved. The method does not require any flags or templates to be passed in as they (`OMI_FULL_OBJECT`, `OMI_ALL_SIMPLE`, and `OMI_SUCCINCT`) are automatically passed to the server for you.

  Note: if the object exists within the object store prior to calling this method, all of its attributes and associations will be overwritten.

  Parameters:
    `store` - the store to create the object(s) in
    `objectType` - the metadata type of the object
    `objectID` - the object id
  Returns:
    the metadata object
  Throws:
    `MdException`
    `java.rmi.RemoteException`

### getFullObjects

    java.util.List getFullObjects(MdObjectStore store,
                                  java.util.Map<java.lang.String,java.lang.String> objectMap)
                                  throws MdException,
                                         java.rmi.RemoteException

  Performs a GetMetadata request on a set of existing public objecst. A public object is defined as an object that has its PublicType attribute set with a matching entry in the type dictionary.

  This method is mainly a convenience method for retrieving the full metadata representation of the public objects, without requiring you to know which associations need to be passed in via a template. All information for the public objects, including all of its attributes as well as all of its subordinate objects will be retrieved. The method does not require any flags or templates to be passed in as they (`OMI_FULL_OBJECT`, `OMI_ALL_SIMPLE`, and `OMI_SUCCINCT`) are automatically passed to the server for you.

  Note: if an object exists within the object store prior to calling this method, all of its attributes and associations will be overwritten.

  Parameters:
    `store` - the store to create the object(s) in
    `objectMap` - map of the objects to retrieve from the server. Keys for the map must be the metadata object ids, and the values must be the metadata object types.
  Returns:
    list of metadata (CMetadata) objects
  Throws:
    `MdException`
    `java.rmi.RemoteException`

### getMetadataSimple

    java.lang.String getMetadataSimple(java.lang.String strType,
                                       java.lang.String strFQID,
                                       java.lang.String attributeName)
                                       throws MdException,
                                              java.rmi.RemoteException

  Returns a single attribute value from the server. The attribute is returned as a String. If the attribute cannot be found on the server, an empty string is returned.

  Parameters:
    `strType` - Type of Metadata object we are fetching the data for
    `strFQID` - Unique ID of the metadata object we are fetching the data for
    `attributeName` - the name of the attribute to retrieve (ex. MdFactory.NAME or MdFactory.DESC)
  Returns:
    the attribute value
  Throws:
    `MdException` - in the case of any server errors
    `java.rmi.RemoteException`

### getMetadataSimple

    java.util.List<java.lang.String> getMetadataSimple(java.lang.String strType,
                                                       java.lang.String strFQID,
                                                       java.util.List<java.lang.String> attributes)
                                                       throws MdException,
                                                              java.rmi.RemoteException

  Returns a List of the simple attributes requested; these objects have been parsed and are returned as Strings in the order they were requested

  Parameters:
    `strType` - - Type of Metadata object we are fetching the data for (WTABLE, WCOLUMN, etc.) NOTE: CASE SENSITIVE!!!!
    `strFQID` - - Unique ID of the metadata object we are fetching the data for
    `attributes` - - List of Strings containing the names of the attributes to fetch NOTE: CASE SENSITIVE! USE THE STATIC VARS in m_factory
  Returns:
    - List of String objects containing the attribute values returned from the server
  Throws:
    `MdException` - in the case of any server errors
    `java.rmi.RemoteException`

### getMetadataAllDepths

    CMetadata getMetadataAllDepths(CMetadata object,
                                   java.util.List<java.lang.String> inSimpleAttr,
                                   java.util.List<java.lang.String> inComplexObject,
                                   java.lang.String strTemplate,
                                   int iOptions)
                                   throws MdException,
                                          java.rmi.RemoteException

  This method constructs CMetadata objects and sets both simple and complex attributes. The call to the metadata server can return any depth of XML. This method will recursively define each object and return the outermost object.

  Parameters:
    `object` - - Metadata object to get data for
    `inSimpleAttr` - - list of the simple attributes to fetch for this object you dont need any if you dont want any; Also, if you pass in an empty List, and set the iOptions field to OMI_ALL | OMI_ALL_SIMPLE (9) you can get back all the simple attributes for this metadata object. inSimpleAttr will be filled in with the attribute name, and outSimpleAttr will contain the attribute value.
    `inComplexObject` - - list of the complex objects to get for this object (WCOLUMN, JOB, etc.)
    `strTemplate` - - the template you want to apply to this object
    `iOptions` - - Options to pass in with this call to the server. Valid values are defined as:
    - OMI_ALL - returns all associations for the objects
    - OMI_ALL_SIMPLE - returns all simple attributes for the objects
    - OMI_TEMPLATE - required if a template is passed in
    - OMI_XMLSELECT - required if an xml select string is passed in
    - OMI_SUCCINCT - used to omit attributes that do not contain values or that contain null values
    - OMI_GET_METADATA - performs a get metadata request on each object
  Returns:
    CMetadata object with both simple and complex attributes set.
  Throws:
    `MdException` - in the case of any server errors
    `java.rmi.RemoteException`

### getMetadataAllDepths

    CMetadata getMetadataAllDepths(CMetadata object,
                                   java.util.List<java.lang.String> inSimpleAttr,
                                   java.util.List<java.lang.String> inComplexObject,
                                   java.lang.String strTemplate,
                                   int iOptions,
                                   boolean doNotOverrideAssocs)
                                   throws MdException,
                                          java.rmi.RemoteException

  This method constructs CMetadata objects and sets both simple and complex attributes. The call to the metadata server can return any depth of XML. This method will recursively define each object and return the outermost object.

  Parameters:
    `object` - - Metadata object to get data for
    `inSimpleAttr` - - list of the simple attributes to fetch for this object you dont need any if you dont want any; Also, if you pass in an empty List, and set the iOptions field to OMI_ALL | OMI_ALL_SIMPLE (9) you can get back all the simple attributes for this metadata object. inSimpleAttr will be filled in with the attribute name, and outSimpleAttr will contain the attribute value.
    `inComplexObject` - - list of the complex objects to get for this object (WCOLUMN, JOB, etc.)
    `strTemplate` - - the template you want to apply to this object
    `iOptions` - - Options to pass in with this call to the server. Valid values are defined as:
    - OMI_ALL - returns all associations for the objects
    - OMI_ALL_SIMPLE - returns all simple attributes for the objects
    - OMI_TEMPLATE - required if a template is passed in
    - OMI_XMLSELECT - required if an xml select string is passed in
    - OMI_SUCCINCT - used to omit attributes that do not contain values or that contain null values
    - OMI_GET_METADATA - performs a get metadata request on each object
  Returns:
    CMetadata object with both simple and complex attributes set.
  Throws:
    `MdException` - in the case of any server errors
    `java.rmi.RemoteException`

### getMetadataAllDepths

    CMetadata getMetadataAllDepths(MdStore inStore,
                                   java.lang.String strType,
                                   java.lang.String strFQID,
                                   java.util.List<java.lang.String> inSimpleAttr,
                                   java.util.List<java.lang.String> inComplexObject,
                                   java.lang.String strTemplate,
                                   int iOptions)
                                   throws MdException,
                                          java.rmi.RemoteException

  This method constructs CMetadata objects and sets both simple and complex attributes. The call to the metadata server can return any depth of XML. This method will recursively define each object and return the outermost object.

  Parameters:
    `inStore` - MdStore the store to create new objects into.
    `strType` - - Type of Metadata object we are fetching the data for (WTABLE, WCOLUMN, etc.) NOTE: CASE SENSITIVE!!!!
    `strFQID` - - Unique ID of the metadata object we are fetching the data for
    `inSimpleAttr` - - list of the simple attributes to fetch for this object you dont need any if you dont want any; Also, if you pass in an empty List, and set the iOptions field to OMI_ALL | OMI_ALL_SIMPLE (9) you can get back all the simple attributes for this metadata object. inSimpleAttr will be filled in with the attribute name, and outSimpleAttr will contain the attribute value.
    `inComplexObject` - - list of the complex objects to get for this object (WCOLUMN, JOB, etc.)
    `strTemplate` - - the template you want to apply to this object
    `iOptions` - - Options to pass in with this call to the server. Valid values are defined as:
    - OMI_ALL - returns all associations for the objects
    - OMI_ALL_SIMPLE - returns all simple attributes for the objects
    - OMI_TEMPLATE - required if a template is passed in
    - OMI_XMLSELECT - required if an xml select string is passed in
    - OMI_SUCCINCT - used to omit attributes that do not contain values or that contain null values
    - OMI_GET_METADATA - performs a get metadata request on each object
  Returns:
    CMetadata object with both simple and complex attributes set.
  Throws:
    `MdException` - in the case of any server errors
    `java.rmi.RemoteException`

### getMetadataAllDepths

    CMetadata getMetadataAllDepths(MdStore inStore,
                                   java.lang.String strType,
                                   java.lang.String strFQID,
                                   java.util.List<java.lang.String> inSimpleAttr,
                                   java.util.List<java.lang.String> inComplexObject,
                                   java.lang.String strTemplate,
                                   int iOptions,
                                   boolean doNotOverrideAssocs)
                                   throws MdException,
                                          java.rmi.RemoteException

  This method constructs CMetadata objects and sets both simple and complex attributes. The call to the metadata server can return any depth of XML. This method will recursively define each object and return the outermost object.

  Parameters:
    `inStore` - MdStore the store to create new objects into.
    `strType` - - Type of Metadata object we are fetching the data for (WTABLE, WCOLUMN, etc.) NOTE: CASE SENSITIVE!!!!
    `strFQID` - - Unique ID of the metadata object we are fetching the data for
    `inSimpleAttr` - - list of the simple attributes to fetch for this object you dont need any if you dont want any; Also, if you pass in an empty List, and set the iOptions field to OMI_ALL | OMI_ALL_SIMPLE (9) you can get back all the simple attributes for this metadata object. inSimpleAttr will be filled in with the attribute name, and outSimpleAttr will contain the attribute value.
    `inComplexObject` - - list of the complex objects to get for this object (WCOLUMN, JOB, etc.)
    `strTemplate` - - the template you want to apply to this object
    `iOptions` - - Options to pass in with this call to the server. Valid values are defined as:
    - OMI_ALL - returns all associations for the objects
    - OMI_ALL_SIMPLE - returns all simple attributes for the objects
    - OMI_TEMPLATE - required if a template is passed in
    - OMI_XMLSELECT - required if an xml select string is passed in
    - OMI_SUCCINCT - used to omit attributes that do not contain values or that contain null values
    - OMI_GET_METADATA - performs a get metadata request on each object
  Returns:
    CMetadata object with both simple and complex attributes set.
  Throws:
    `MdException` - in the case of any server errors
    `java.rmi.RemoteException`

### populateStoreFromString

    void populateStoreFromString(MdStore inStore,
                                 org.w3c.dom.Document doc,
                                 int state,
                                 boolean useReposForNewObjects)
                                 throws MdException,
                                        java.rmi.RemoteException

  Build objects from source XML and set states to desired state.

  Parameters:
    `inStore` - the store to create the objects in
    `doc` - the xml document containing the metadata to create
    `state` - Valid states are MetadataState.LOCAL & MetadataState.SERVER
  Throws:
    `MdException` - If error getting/setting data on object.
    `java.rmi.RemoteException`

### populateStoreFromString

    void populateStoreFromString(MdStore inStore,
                                 java.lang.String inXML,
                                 int state,
                                 boolean useReposForNewObjects)
                                 throws MdException,
                                        java.rmi.RemoteException

  Build objects from source XML and set states to desired state.

  Parameters:
    `inStore` - the store to create the objects in
    `inXML` - the xml containing the metadata to create
    `state` - Valid states are MetadataState.LOCAL & MetadataState.SERVER
  Throws:
    `MdException` - If error getting/setting data on object.
    `java.rmi.RemoteException`

### populateStoreFromInputStream

    void populateStoreFromInputStream(MdStore inStore,
                                      java.io.InputStream stream,
                                      int state,
                                      boolean useReposForNewObjects)
                                      throws MdException,
                                             java.rmi.RemoteException

  Build objects from an input stream and set states to desired state.

  Parameters:
    `inStore` - the store to create the objects in
    `stream` - The input stream containing the xml to be parsed
    `state` - Valid states are MetadataState.LOCAL & MetadataState.SERVER
  Throws:
    `MdException` - If error getting/setting data on object.
    `java.rmi.RemoteException`

### populateObject

    CMetadata populateObject(CMetadata metaObject,
                             org.w3c.dom.NamedNodeMap simpleNodeMap,
                             org.w3c.dom.NodeList complexNodeList)
                             throws MdException,
                                    java.rmi.RemoteException

  Populates an objects simple and complex attributes, by what is in the simpleNodeMap and the complexNodeList.

  Parameters:
    `metaObject` - CMetadata
    `simpleNodeMap` - org.w3c.dom.NamedNodeMap
    `complexNodeList` - org.w3c.dom.NodeList
  Returns:
    CMetadata object that is populated
  Throws:
    `MdException` - in the case of any server errors
    `java.rmi.RemoteException`

### populateObject

    CMetadata populateObject(CMetadata metaObject,
                             org.w3c.dom.NamedNodeMap simpleNodeMap,
                             org.w3c.dom.NodeList complexNodeList,
                             boolean doNotOverrideAssocs)
                             throws MdException,
                                    java.rmi.RemoteException

  Populates an objects simple and complex attributes, by what is in the simpleNodeMap and the complexNodeList.

  Parameters:
    `metaObject` - CMetadata
    `simpleNodeMap` - org.w3c.dom.NamedNodeMap
    `complexNodeList` - org.w3c.dom.NodeList
  Returns:
    CMetadata object that is populated
  Throws:
    `MdException` - in the case of any server errors
    `java.rmi.RemoteException`

### populateObjects

    java.util.List populateObjects(CMetadata metaObject,
                                   org.w3c.dom.NamedNodeMap simpleNodeMap,
                                   org.w3c.dom.NodeList complexNodeList,
                                   boolean doNotOverrideAssocs,
                                   java.util.List objects)
                                   throws MdException,
                                          java.rmi.RemoteException

  Populates an objects simple and complex attributes, by what is in the simpleNodeMap and the complexNodeList.

  Parameters:
    `metaObject` - CMetadata
    `simpleNodeMap` - org.w3c.dom.NamedNodeMap
    `complexNodeList` - org.w3c.dom.NodeList
  Returns:
    CMetadata object that is populated
  Throws:
    `MdException` - in the case of any server errors
    `java.rmi.RemoteException`

### doSimple

    CMetadata doSimple(CMetadata thisObject,
                       org.w3c.dom.NamedNodeMap thisNodeMap)
                       throws MdException,
                              java.rmi.RemoteException

  Calls 'set' methods for given object for nodes in given NodeMap

  Parameters:
    `thisObject` - CMetadata
    `thisNodeMap` - org.w3c.dom.NamedNodeMap
  Returns:
    CMetadata object that is populated with attributes
  Throws:
    `MdException` - in the case of any errors in reflection setting values
    `java.rmi.RemoteException`

### setObjectAssociations

    void setObjectAssociations(CMetadata metaObject,
                               java.util.List outComplexNames,
                               java.util.List[] outComplexObjects,
                               boolean doNotOverrideAssns)
                               throws MdException,
                                      java.rmi.RemoteException

  Call given object's 'set...s' methods for the given complex attributes

  Parameters:
    `metaObject` - CMetadata
    `outComplexNames` - List
    `outComplexObjects` - List[]
  Throws:
    `MdException` - if error in reflection.
    `java.rmi.RemoteException`

### getUserHomeFolderName

    java.lang.String getUserHomeFolderName(java.lang.String userName,
                                           java.lang.String folderName)
                                           throws java.rmi.RemoteException

  Returns the localized name of a user's home folder. If the user's home folder does not yet exist, this method will not attempt to create it. Instead, it will just return the localized name of the folder if it did happen to exist.

  This method is guaranteed to at least return the original folder name if the localized version can't be found.

  Parameters:
    `userName` - the name of th euser
    `folderName` - the type of folder to return. Valid values are:
    - `FOLDERTYPE_HOME`
    - `FOLDERTYPE_MYFOLDER`
    - `FOLDERTYPE_APPDATA`
  Returns:
    the localized name of the user's home folder
  Throws:
    `java.rmi.RemoteException`

### getUserHomeFolder

    Tree getUserHomeFolder(MdObjectStore store,
                           java.lang.String userName,
                           java.lang.String folderName,
                           java.lang.String template,
                           int flags)
                           throws MdException,
                                  java.rmi.RemoteException

  Returns a home folder for a given user. An exception will be thrown if the home folder does not yet exist for the user.

  Parameters:
    `store` - the object store to create the folder in
    `userName` - the name of the user
    `folderName` - the type of folder to return. Valid values are:
    - `FOLDERTYPE_HOME`
    - `FOLDERTYPE_MYFOLDER`
    - `FOLDERTYPE_APPDATA`
    `template` - the template to apply to this folder
    `flags` -
  Returns:
    returns a Tree metadata object representing a user's home folder.
  Throws:
    `MdException`
    `java.rmi.RemoteException`

### getUserHomeFolder

    Tree getUserHomeFolder(MdObjectStore store,
                           java.lang.String userName,
                           java.lang.String folderName,
                           java.lang.String template,
                           int flags,
                           boolean createIfNecessary)
                           throws MdException,
                                  java.rmi.RemoteException

  Returns a home folder for a given user.

  Parameters:
    `store` - the object store to create the folder in
    `userName` - the name of the user
    `folderName` - the type of folder to return. Valid values are:
    - `FOLDERTYPE_HOME`
    - `FOLDERTYPE_MYFOLDER`
    - `FOLDERTYPE_APPDATA`
    `template` - the template to apply to this folder
    `flags` -
    `createIfNecessary` - if true, the folder will be created if it doesn't yet exist. Otherwise, if false, the folder will not be created.
  Returns:
    returns a Tree metadata object representing a user's home folder.
  Throws:
    `MdException`
    `java.rmi.RemoteException`

### getObjectPath

    java.lang.String getObjectPath(MdObjectStore store,
                                   PrimaryType meta,
                                   boolean includeType)
                                   throws MdException,
                                          java.rmi.RemoteException

  Returns the path of the specified public object. This method should only be used on objects that have a public type definition and that reside in the SAS folders tree.

  Examples of the returned path:
  Library (with the type included): "/Shared Data/Libraries/Oracle Library(Library)"
  Stored Process (without the type included): "/BIP Tree/Report Studio/Samples/Hello World"

  Parameters:
    `store` - the object store to create the objects in
    `publicObject` - the public object
    `includeType` - If true, the public type will be included in the returned path. Otherwise, the type will be ignored.
  Returns:
    the path of the public object.
  Throws:
    `MdException`
    `java.rmi.RemoteException`

### getResponsibleParty

    ResponsibleParty getResponsibleParty(MdObjectStore store,
                                         java.lang.String identityName,
                                         java.lang.String responsibility)
                                         throws MdException,
                                                java.rmi.RemoteException

  Returns a responsible party object for a given identity and responsibility. If the requested responsible party does not exist, it will be created in the same repository where the Identity exists.

  Parameters:
    `store` - the object store to create the responsible party in
    `identityName` - the name of the user. A value of `null` will imply the connected user. If the connected user is PUBLIC, an error will be returned.
    `responsibility` - the responsibility to search on (such as Owner or Administrator)
  Returns:
    returns a ResponsibleParty metadata object for a given Identity
  Throws:
    `MdException`
    `java.lang.IllegalArgumentException` - if responsibility is not provided
    `java.rmi.RemoteException`

### getResponsibleParty

    ResponsibleParty getResponsibleParty(MdObjectStore store,
                                         java.lang.String identityName,
                                         java.lang.String responsibility,
                                         java.lang.String template,
                                         int flags)
                                         throws MdException,
                                                java.rmi.RemoteException

  Returns a responsible party object for a given identity and responsibility. If the request responsible party does not exist, it will be created in the same repository where the Identity exists.

  Parameters:
    `store` - the object store to create the responsible party in
    `identityName` - the name of the user. A value of `null` will imply the connected user. If the connected user is PUBLIC, an error will be returned.
    `responsibility` - the responsibility to search on (such as Owner or Administrator)
    `template` - the template to apply to this responsible party (optional)
    `flags` - additional flags to be used when searching for the responsible party
  Returns:
    returns a ResponsibleParty metadata object for a given Identity
  Throws:
    `MdException`
    `java.lang.IllegalArgumentException` - if responsibility is not provided
    `java.rmi.RemoteException`

### doesObjectExist

    int doesObjectExist(java.lang.String reposID,
                        java.lang.String objectType,
                        java.lang.String xmlSelect)
                        throws MdException,
                               java.rmi.RemoteException

  Returns whether an object exists on the metadata server. This method should be used to determine if objects that match a certain criteria exist, and if so, how many exist. This method does not create CMetadata objects.

  Parameters:
    `reposID` - the repository id
    `objectType` - the metadata object type
    `xmlSelect` - an xml select statement to search with
  Returns:
    count of the number of objects found on the server. If no objects are found, 0 is returned.
  Throws:
    `MdException`
    `java.rmi.RemoteException`

### getMetadataObjectsSubset

    java.util.List getMetadataObjectsSubset(MdStore inStore,
                                            java.lang.String strReposID,
                                            java.lang.String strType,
                                            int flags,
                                            java.lang.String options)
                                            throws MdException,
                                                   java.rmi.RemoteException

  Gets the list of metatdata objects in the repository for the requested type.

  Parameters:
    `inStore` - MdStore The store to put the returned objects into.
    `strReposID` - String Repository ID.
    `strType` - String Type of Metadata object we are wanting to list.
    `flags` - int GetMetadataObjects flags.
    `options` - String Template or XMLSelect string to selectively get the objects.
  Returns:
    List of CMetadata objects.
  Throws:
    `MdException` - in the case of any server errors
    `java.rmi.RemoteException`

### getMetadataObjectsSubset

    java.util.List getMetadataObjectsSubset(MdStore inStore,
                                            java.lang.String strReposID,
                                            java.lang.String strType,
                                            int flags,
                                            java.lang.String options,
                                            boolean doOverrideAssocs)
                                            throws MdException,
                                                   java.rmi.RemoteException

  Gets the list of metatdata objects in the repository for the requested type.

  Parameters:
    `inStore` - MdStore The store to put the returned objects into.
    `strReposID` - String Repository ID.
    `strType` - String Type of Metadata object we are wanting to list.
    `flags` - int GetMetadataObjects flags.
    `options` - String Template or XMLSelect string to selectively get the objects.
  Returns:
    List of CMetadata objects.
  Throws:
    `MdException` - in the case of any server errors
    `java.rmi.RemoteException`

### getMetadataObjectsSubsetList

    java.util.List getMetadataObjectsSubsetList(MdStore inStore,
                                                java.lang.String strReposID,
                                                java.lang.String strType,
                                                int flags,
                                                java.lang.String options,
                                                boolean doOverrideAssocs)
                                                throws MdException,
                                                       java.rmi.RemoteException

  Gets the list of metatdata objects in the repository for the requested type.

  Parameters:
    `inStore` - MdStore The store to put the returned objects into.
    `strReposID` - String Repository ID.
    `strType` - String Type of Metadata object we are wanting to list.
    `flags` - int GetMetadataObjects flags.
    `options` - String Template or XMLSelect string to selectively get the objects.
  Returns:
    List of CMetadata objects.
  Throws:
    `MdException` - in the case of any server errors
    `java.rmi.RemoteException`

### getMetadataObjects

    java.util.List getMetadataObjects(java.lang.String strReposID,
                                      java.lang.String strType,
                                      int iFlags)
                                      throws MdException,
                                             java.rmi.RemoteException

  Gets the list of metatdata objects in the repository for the requested type.

  Parameters:
    `strReposID` - Repository ID.
    `strType` - Type of Metadata object we are wanting to list.
    `iFlags` - int flags for OMI call
  Returns:
    List of CMetadata objects. Name & ID populated only...
  Throws:
    `MdException` - in the case of any server errors
    `java.rmi.RemoteException`

### getMetadataObjects

    java.util.List getMetadataObjects(java.lang.String strReposID,
                                      java.lang.String strType)
                                      throws MdException,
                                             java.rmi.RemoteException

  Gets the list of metatdata objects in the repository for the requested type.

  Parameters:
    `strReposID` - Repository ID.
    `strType` - Type of Metadata object we are wanting to list.
  Returns:
    List of CMetadata objects. Name & ID populated only...
  Throws:
    `MdException` - in the case of any server errors
    `java.rmi.RemoteException`

### getMetadataObjects

    java.util.List getMetadataObjects(java.lang.String strReposID,
                                      java.lang.String strType,
                                      int flags,
                                      java.lang.String strOptions)
                                      throws MdException,
                                             java.rmi.RemoteException

  Gets the list of metatdata objects in the repository for the requested type.

  Parameters:
    `strReposID` - Repository ID.
    `strType` - Type of Metadata object we are wanting to list.
    `flags` - int GetMetadataObjects flags.
    `strOptions` - String Template or XMLSelect string to selectively get the objects.
  Returns:
    List of CMetadata objects. Name & ID populated only...
  Throws:
    `MdException` - in the case of any server errors
    `java.rmi.RemoteException`

### getMetadata

    java.util.List getMetadata(MdStore store,
                               java.util.Map objectMap,
                               java.lang.String template,
                               int flags)
                               throws MdException,
                                      java.rmi.RemoteException

  Performs a GetMetadata request for a group of objects. The request sent to the server may contain a single object or a list of objects. This method does not allow you to specify which attributes or associations you want returned for each object. A template must be used instead.

  Parameters:
    `store` - the store to create the objects in
    `objectMap` - a map of the objects to retrieve from the server. Keys for the map must be the metadata object ids, and the values must be the metadata object types.
    `template` - the template you want to apply to these objects
    `flags` - Options to pass in with this call to the server. Valid values are defined as:
    - OMI_ALL - returns all associations for the objects
    - OMI_ALL_SIMPLE - returns all simple attributes for the objects
    - OMI_TEMPLATE - required if a template is passed in
    - OMI_XMLSELECT - required if an xml select string is passed in
    - OMI_SUCCINCT - used to omit attributes that do not contain values or that contain null values
    - OMI_GET_METADATA - performs a get metadata request on each object
  Returns:
    a List of CMetadata objects
  Throws:
    `MdException`
    `java.rmi.RemoteException`

### getMetadata

    java.util.List getMetadata(MdStore store,
                               java.util.Map objectMap,
                               java.lang.String template,
                               int flags,
                               boolean doNotOverrideAssocs,
                               boolean doNotOverrideAttrs)
                               throws MdException,
                                      java.rmi.RemoteException

  Performs a GetMetadata request for a group of objects. The request sent to the server may contain a single object or a list of objects. This method does not allow you to specify which attributes or associations you want returned for each object. A template must be used instead.

  Parameters:
    `store` - the store to create the objects in
    `objectMap` - a map of the objects to retrieve from the server. Keys for the map must be the metadata object ids, and the values must be the metadata object types.
    `template` - the template you want to apply to these objects
    `flags` - Options to pass in with this call to the server. Valid values are defined as:
    - OMI_ALL - returns all associations for the objects
    - OMI_ALL_SIMPLE - returns all simple attributes for the objects
    - OMI_TEMPLATE - required if a template is passed in
    - OMI_XMLSELECT - required if an xml select string is passed in
    - OMI_SUCCINCT - used to omit attributes that do not contain values or that contain null values
    - OMI_GET_METADATA - performs a get metadata request on each object
    `doNotOverrideAssocs` - if true, already set associations will not be overridden
    `doNotOverrideAttrs` - if true, already set attributes will not be overridden
  Returns:
    a List of CMetadata objects
  Throws:
    `MdException`
    `java.rmi.RemoteException`

### getMetadata

    org.w3c.dom.Document getMetadata(java.lang.String inXML,
                                     int iFlags)
                                     throws MdException,
                                            java.rmi.RemoteException

  Sends input XML string to metadata server, and parses the output XML into a DOM document.

  Parameters:
    `inXML` - - Input XML string.
    `iFlags` - - OMI server GetMetadata flags.
  Returns:
    DOM Document.
  Throws:
    `MdException` - in the case of any from server
    `java.rmi.RemoteException`

### getMetadata

    org.w3c.dom.Document getMetadata(java.lang.String inXML,
                                     java.lang.String strTemplate,
                                     int iFlags)
                                     throws MdException,
                                            java.rmi.RemoteException

  Sends input and template XML strings to metadata server, and parses the output XML into a DOM document.

  Parameters:
    `inXML` - - Input XML string.
    `strTemplate` - - Template XML string.
    `iFlags` - - OMI server GetMetadata flags.
  Returns:
    DOM Document.
  Throws:
    `MdException` - in the case of any server errors
    `java.rmi.RemoteException`

### getMetadataObjects

    java.util.List getMetadataObjects(MdStore inStore,
                                      java.lang.String inXML,
                                      java.lang.String strTemplate,
                                      int iFlags)
                                      throws MdException,
                                             java.rmi.RemoteException

  Sends input and template XML strings to metadata server, and parses the output XML into a List of objects contained in the inStore.

  Parameters:
    `inStore` - MdStore The store to put created objects into.
    `inXML` - String the XML for the objects requested.
    `strTemplate` - - Template XML string.
    `iFlags` - - OMI server GetMetadata flags.
  Returns:
    DOM Document.
  Throws:
    `MdException` - in the case of any server errors
    `java.rmi.RemoteException`

### getMetadataObjects

    java.util.List getMetadataObjects(MdStore inStore,
                                      java.lang.String inXML,
                                      java.lang.String strTemplate,
                                      int iFlags,
                                      boolean doNotOverrideAssocs)
                                      throws MdException,
                                             java.rmi.RemoteException

  Sends input and template XML strings to metadata server, and parses the output XML into a List of objects contained in the inStore.

  Parameters:
    `inStore` - MdStore The store to put created objects into.
    `inXML` - String the XML for the objects requested.
    `strTemplate` - - Template XML string.
    `iFlags` - - OMI server GetMetadata flags.
  Returns:
    DOM Document.
  Throws:
    `MdException` - in the case of any server errors
    `java.rmi.RemoteException`

### getMetadataNoCache

    java.util.Map getMetadataNoCache(java.lang.String strType,
                                     java.lang.String strFQID,
                                     java.lang.String strOptions,
                                     int iFlags)
                                     throws MdException,
                                            java.rmi.RemoteException

  Performs a GetMetadata request against the server. The xml returned from the server is parsed and stored in a map. This map will contain all of the object's attributes and associations returned from the server.

  In the case of the attributes, the attribute name will be the key and the attribute value will be the map's value. For the associations, the association name will be the key and the value will be a list of the associated objects. Each item in the list will be a separate map object.

  Note: This method will not create complex objects out of the items returned from the server and nothing will be cached in an object store. This method should only be used when the user wishes to have only basic information for an object. The information returned can be restricted by the use of a template.

  Parameters:
    `strType` - the type of metadata object
    `strFQID` - the metadata object id
    `strOptions` - the xml options (including any templates or search statements)
    `iFlags` - OMI server GetMetadata flags
  Returns:
    a map of the object
  Throws:
    `MdException`
    `java.rmi.RemoteException`

### getMetadataNoCache

    java.util.List getMetadataNoCache(java.util.Map objectMap,
                                      java.lang.String strOptions,
                                      int iFlags)
                                      throws MdException,
                                             java.rmi.RemoteException

  Performs a GetMetadata request against the server. This method allows you to perform a GetMetadata on multiple objects. The xml returned from the server is parsed and stored in a map. This map will contain all of the object's attributes and associations returned from the server.

  In the case of the attributes, the attribute name will be the key and the attribute value will be the map's value. For the associations, the association name will be the key and the value will be a list of the associated objects. Each item in the list will be a separate map object.

  Note: This method will not create complex objects out of the items returned from the server and nothing will be cached in an object store.

  Parameters:
    `connectionHandle` - the IOMI interface used to process methods.
    `objectMap` - a map of id/type values to search for. The maps keys must be an object's metadata id, and the values must be the metadata object types.
    `strOptions` - the xml options (including any templates or search statements)
    `iFlags` - OMI server GetMetadata flags
  Returns:
    a list containing map objects
  Throws:
    `MdException`
    `java.rmi.RemoteException`

### getMetadataObjectsNoCache

    java.util.List getMetadataObjectsNoCache(java.lang.String strType,
                                             java.lang.String strReposId,
                                             java.lang.String strOptions,
                                             int iFlags)
                                             throws MdException,
                                                    java.rmi.RemoteException

  Performs a GetMetadataObjects request against the server. Each object returned from the server is parsed and stored in a map. This map will contain all of the object's attributes and associations returned from the server. A list is then created containing all of the map objects created.

  In the case of the attributes, the attribute name will be the key and the attribute value will be the map's value. For the associations, the association name will be the key and the value will be a list of the associated objects. Each item in the list will be a separate map object.

  Note: This method will not create complex objects out of the items returned from the server and nothing will be cached in an object store. This method should only be used when the user wishes to have only basic information for an object. The information returned can be restricted by the use of a template.

  Parameters:
    `strType` - the type of metadata object
    `strReposId` - the repository id
    `strOptions` - the xml options (including any templates or search statements)
    `iFlags` - OMI server GetMetadata flags
  Returns:
    a list containing map objects
  Throws:
    `MdException`
    `java.rmi.RemoteException`

### DoRequest

    org.w3c.dom.Document DoRequest(java.lang.String inXML)
                                   throws MdException,
                                          java.rmi.RemoteException

  Performs a DoRequest

  Parameters:
    `inXML` - String input for DoRequest Call
  Returns:
    org.w3c.dom.Document that is the parsed xml output from DoRequest call to server
  Throws:
    `MdException` - in the case of any server errors
    `java.rmi.RemoteException`

### DoRequest

    org.w3c.dom.Document DoRequest(java.lang.String inXML,
                                   boolean fUpdateIds)
                                   throws MdException,
                                          java.rmi.RemoteException

  Performs a DoRequest

  Parameters:
    `inXML` - String input for DoRequest Call
  Returns:
    org.w3c.dom.Document that is the parsed xml output from DoRequest call to server
  Throws:
    `MdException` - in the case of any server errors
    `java.rmi.RemoteException`

### DoRequestNoReturn

    void DoRequestNoReturn(java.lang.String inXML,
                           boolean fUpdateIds)
                           throws MdException,
                                  java.rmi.RemoteException

  Performs a DoRequest

  Parameters:
    `inXML` - String input for DoRequest Call
  Throws:
    `MdException` - in the case of any server errors
    `java.rmi.RemoteException`

### processDeletedObjects

    void processDeletedObjects(org.w3c.dom.Document outDoc)
                               throws java.rmi.RemoteException

  This deletes objects on the client that have been deleted from the server and are returned from a DeltedObjects array.

  Parameters:
    `outDoc` -
  Throws:
    `java.rmi.RemoteException`

### updateObjectId

    void updateObjectId(org.w3c.dom.Document inDoc,
                        org.w3c.dom.Document outDoc)
                        throws MdException,
                               java.rmi.RemoteException

  Updates the object ids on the local server stores to reflect the new id on the server.

  Parameters:
    `inDoc` - org.w3c.dom.Document
    `outDoc` - org.w3c.dom.Document
  Throws:
    `MdException` - in the case of any errors from the factory changing the hashkey.
    `java.rmi.RemoteException`

### createGetXMLString

    java.lang.String createGetXMLString(java.lang.String strType,
                                        java.lang.String strFQID,
                                        java.util.List<java.lang.String> simpleAttr,
                                        java.util.List<java.lang.String> complexAttr)
                                        throws java.rmi.RemoteException

  Creates and returns the XML string to retrieve simple and/or complex attributes.

  Parameters:
    `strType` - - XML is generated for this type of metadata object.
    `strFQID` - - Metadata-id, if get is for specific object. May be null or empty.
    `simpleAttr` - - List of simple attributes requested. May be null or empty.
    `complexAttr` - - List of complex attributes requested. May be null or empty.
  Returns:
    - String object with generated XML.
  Throws:
    `java.rmi.RemoteException`

### createGetXMLString

    java.lang.String createGetXMLString(java.util.Map<java.lang.String,java.lang.String> objectMap)
                                        throws java.rmi.RemoteException

  Creates and returns the XML string used for a GetMetadata request. This string does not include simple attributes or associations.

  Parameters:
    `objectMap` - a map of the objects to retrieve. Keys for the map must be the metadata object ids and the values must be the metadata object type.
  Returns:
    String object with generated XML.
  Throws:
    `java.rmi.RemoteException`

### createObjectAttributeString

    java.lang.String createObjectAttributeString(java.util.Map<java.lang.String,java.lang.String> attributes)
                                                 throws java.rmi.RemoteException

  Creates a string of an object's attributes as key/value pairs

  Parameters:
    `attributes` - a map of the object's attributes
  Returns:
    a String that is the attribues and values formated for XML
  Throws:
    `java.rmi.RemoteException`

### createXMLSubString

    java.lang.String createXMLSubString(java.util.List<java.lang.String> attributes,
                                        java.util.List<java.lang.String> values)
                                        throws java.rmi.RemoteException

  Creates and returns the XML string of the passed in attributes

  Parameters:
    `attributes` - - List of Strings containing the names of the attributes to fetch NOTE: CASE SENSITIVE! USE THE STATIC VARS in m_factory
    `values` - - List of String objects containing the attribute values
  Returns:
    String that is the attribues and values formated for XML
  Throws:
    `java.rmi.RemoteException`

### createRefreshXML

    java.lang.String createRefreshXML(CMetadata meta,
                                      boolean refreshAssocsSetByServerOnly,
                                      boolean refreshAll)
                                      throws java.rmi.RemoteException

  Creates an XML string used for refreshing an object.

  Parameters:
    `meta` - the object to refresh
    `refreshAssocsSetByServerOnly` - refresh associations that have been set by the server only
    `refreshAll` - refreshes all associations of the object
  Returns:
    refresh xml string
  Throws:
    `java.rmi.RemoteException`

### cleanStringForXML

    java.lang.String cleanStringForXML(java.lang.String s)
                                       throws java.rmi.RemoteException

  cleanStringForXML takes a String and converts "bad" characters, like \n and others, into acceptable &#xxx entities.

  Parameters:
    `s` - String
  Returns:
    String that is free from special chars
  Throws:
    `java.rmi.RemoteException`

### createUpdateXMLSimple

    java.lang.String createUpdateXMLSimple(java.lang.String strType,
                                           java.lang.String strFQID,
                                           java.util.List<java.lang.String> attributes,
                                           java.util.List<java.lang.String> values)
                                           throws java.rmi.RemoteException

  Creates and returns the XML string of the passed in attributes

  Parameters:
    `strType` - - Type of Metadata object we are fetching the data for (WTABLE, WCOLUMN, etc.) NOTE: CASE SENSITIVE!!!!
    `strFQID` - - Unique ID of the metadata object we are updating
    `attributes` - - List of Strings containing the names of the attributes to fetch NOTE: CASE SENSITIVE! USE THE STATIC VARS in m_factory
    `values` - - List of String objects containing the attribute values to be sent to the server
  Returns:
    String that is the update xml for the simple attributes specified
  Throws:
    `java.rmi.RemoteException`

### updateMetadataSimple

    void updateMetadataSimple(java.lang.String strType,
                              java.lang.String strFQID,
                              java.util.List<java.lang.String> attributes,
                              java.util.List<java.lang.String> values)
                              throws MdException,
                                     java.rmi.RemoteException

  Updates the values of the simple attributes given.

  Parameters:
    `strType` - - Type of Metadata object we are fetching the data for (WTABLE, WCOLUMN, etc.) NOTE: CASE SENSITIVE!!!!
    `strFQID` - - Unique ID of the metadata object we are updating
    `attributes` - - List of Strings containing the names of the attributes to fetch NOTE: CASE SENSITIVE! USE THE STATIC VARS in m_factory
    `values` - - List of String objects containing the attribute values to be sent to the server
  Throws:
    `MdException` - in the case of any server errors
    `java.rmi.RemoteException`

### updateMetadataSimple

    void updateMetadataSimple(java.lang.String inXML)
                              throws MdException,
                                     java.rmi.RemoteException

  Throws:
    `MdException`
    `java.rmi.RemoteException`

### updateMetadata

    void updateMetadata(java.lang.String inXML)
                        throws MdException,
                               java.rmi.RemoteException

  Throws:
    `MdException`
    `java.rmi.RemoteException`

### updateMetadata

    int updateMetadata(java.lang.String inXML,
                       org.omg.CORBA.StringHolder outXML,
                       int iFlags)
                       throws MdException,
                              java.rmi.RemoteException

  Performs an update operation against the metadata server.

  Parameters:
    `inXML` - Input XML string that will be wrapped with the update tag and other session tags. ie.
    `outXML` - StringHodler object containing the XML returned from the server. This may contain new object IDs if new objects were created.
    `iFlags` - int Set to zero.
  Returns:
    int return code from updateMetadata
  Throws:
    `MdException` - in the case of any server errors
    `java.rmi.RemoteException`

### addMetadata

    int addMetadata(java.lang.String inXML,
                    java.lang.String reposID,
                    org.omg.CORBA.StringHolder outXML,
                    int iFlags)
                    throws MdException,
                           java.rmi.RemoteException

  Performs an add operation against the metadata server.

  Parameters:
    `inXML` - Input XML string that will be wrapped with the add tag and other session tags. ie.
    `reposID` - String representation of an ID in the repository to create the object in. You can pass in any existing object's ID.
    `outXML` - StringHodler object containing the XML returned from the server. This may contain new object IDs if new objects were created.
    `iFlags` - int Flags Set to zero.
  Returns:
    int return code from addMetadata
  Throws:
    `MdException` - in the case of any server errors
    `java.rmi.RemoteException`

### getTypes

    void getTypes(java.util.List<java.lang.String> nameList,
                  java.util.List<java.lang.String> descList)
                  throws MdException,
                         java.rmi.RemoteException

  Gets the types that are available in the repository. Usage:
  List nameList = new List();
  List descList = new List();
  MdOMIUtil.getTypes( nameList, descList )

  Parameters:
    `nameList` - List of string type names being returned.
    `descList` - List of string descriptions being returned.
  Throws:
    `MdException` - in the case of any server errors
    `java.rmi.RemoteException`

### getTypeProperties

    void getTypeProperties(java.lang.String objectType,
                           java.util.Map<java.lang.String,java.util.Map<java.lang.String,java.lang.String>> attributeMap,
                           java.util.Map<java.lang.String,java.util.Map<java.lang.String,java.lang.String>> associationMap)
                           throws MdException,
                                  java.rmi.RemoteException

  Gets the properties for a specific metadata object type. This will call the GetTypeProperties method on the server and retrieve a map of an object's attributes and associations.

  Usage:

       Map> attributeMap = new HashMap>();
       Map> associationMap = new HashMap>();
       MdOMIUtil.getTypeProperties(MdFactory.COLUMN, attributeMap, associationMap);

  Parameters:
    `connectionHandle` - The IOMI interface to use to process methods.
    `objectType` - the metadata object type
    `attributeMap` - map of attributes to be returned
    `associationMap` - map of associations to be returned
  Throws:
    `MdException`
    `java.rmi.RemoteException`

### getSubTypes

    java.util.List<java.lang.String> getSubTypes(java.lang.String objectType,
                                                 boolean includeDescendants)
                                                 throws MdException,
                                                        java.rmi.RemoteException

  Gets the subtypes specific metadata object type.

  Parameters:
    `objectType` - the metadata object type
    `includeDescendants` - if true, thye method eturns all subtypes along with all of their descendants.
  Throws:
    `MdException`
    `java.rmi.RemoteException`

### getAssociatedObject

    CMetadata getAssociatedObject(CMetadata object,
                                  java.lang.String strAssociation,
                                  java.lang.String strTemplate)
                                  throws MdException,
                                         java.rmi.RemoteException

  Get the single metatdata object from the given associtation.

  Parameters:
    `object` - CMetadata
    `strAssociation` - name to follow and retrieve objects.
    `strTemplate` - - the template you want to apply to the associated object, an empty string can be used is no template is needed.
  Returns:
    CMetadata object associated or null if none found.
  Throws:
    `MdException` - in the case of any server errors
    `java.rmi.RemoteException`

### getAssociatedObject

    CMetadata getAssociatedObject(CMetadata object,
                                  java.lang.String strAssociation,
                                  java.lang.String strTemplate,
                                  boolean doNotOverrideAssocs)
                                  throws MdException,
                                         java.rmi.RemoteException

  Get the single metatdata object from the given associtation.

  Parameters:
    `object` - CMetadata
    `strAssociation` - name to follow and retrieve objects.
    `strTemplate` - - the template you want to apply to the associated object, an empty string can be used is no template is needed.
  Returns:
    CMetadata object associated or null if none found.
  Throws:
    `MdException` - in the case of any server errors
    `java.rmi.RemoteException`

### getAssociatedObjects

    AssociationList getAssociatedObjects(CMetadata object,
                                         java.lang.String strAssociation,
                                         java.lang.String strTemplate)
                                         throws MdException,
                                                java.rmi.RemoteException

  Gets the list of metatdata objects for the given association.

  Parameters:
    `object` - CMetadata object used to get assocaition
    `strAssociation` - name to follow and retrieve objects.
    `strTemplate` - - the template you want to apply to the associated objects, an empty string can be used is no template is needed.
  Returns:
    List of CMetadata objects associated to the given object.
  Throws:
    `MdException` - in the case of any server errors
    `java.rmi.RemoteException`

### getAssociatedObjects

    AssociationList getAssociatedObjects(CMetadata object,
                                         java.lang.String strAssociation,
                                         java.lang.String strTemplate,
                                         boolean doNotOverrideAssocs)
                                         throws MdException,
                                                java.rmi.RemoteException

  Gets the list of metatdata objects for the given association.

  Parameters:
    `object` - CMetadata object used to get assocaition
    `strAssociation` - name to follow and retrieve objects.
    `strTemplate` - - the template you want to apply to the associated objects, an empty string can be used is no template is needed.
  Returns:
    List of CMetadata objects associated to the given object.
  Throws:
    `MdException` - in the case of any server errors
    `java.rmi.RemoteException`

### getAttribute

    java.lang.String getAttribute(java.lang.String strAttribute,
                                  org.w3c.dom.NamedNodeMap childNodeMap)
                                  throws java.rmi.RemoteException

  Retrieve the requested attribute from the XML dom object.

  Parameters:
    `strAttribute` - String
    `childNodeMap` - org.w3c.dom.NamedNodeMap
  Returns:
    Null if no value defined, or the String value of the attribute.
  Throws:
    `java.rmi.RemoteException`

### parseXML

    org.w3c.dom.Document parseXML(java.lang.String strXML)
                                  throws MdException,
                                         java.rmi.RemoteException

  routine to parse a passed in xml string and return a dom document

  Parameters:
    `strXML` - String is the string input to pass to the parser
  Returns:
    a dom document that can be traversed for the various xml pieces
  Throws:
    `MdException` - in the case of any parsing exceptions
    `java.rmi.RemoteException`

### parseXML

    org.w3c.dom.Document parseXML(java.net.URL xmlDocument)
                                  throws MdException,
                                         java.rmi.RemoteException

  routine to parse a passed in xml URL and return a dom document

  Parameters:
    `xmlDocument` - URL is the string input to pass to the parser
  Returns:
    a dom document that can be traversed for the various xml pieces
  Throws:
    `MdException` - in the case of any server errors
    `java.rmi.RemoteException`

### formatXML

    java.lang.String formatXML(java.lang.String original)
                               throws java.rmi.RemoteException

  Format the XML so that we can read it easier.

  Parameters:
    `original` - String
  Returns:
    String formated original
  Throws:
    `java.rmi.RemoteException`

### deleteMetadataObject

    java.util.List<java.lang.String> deleteMetadataObject(CMetadata metadataObject,
                                                          java.lang.String template)
                                                          throws MdException,
                                                                 java.rmi.RemoteException

  Deletes an object from the server using the specified delete template.

  Parameters:
    `metadataObject` - the object to delete
    `template` - the template to process when deleting the public object
  Returns:
    list of object ids (Strings) that were deleted
  Throws:
    `MdException`
    `java.rmi.RemoteException`

### deleteMetadataObject

    java.util.List<java.lang.String> deleteMetadataObject(CMetadata inObject)
                                                          throws MdException,
                                                                 java.rmi.RemoteException

  Delete a CMetadata object and all it's dependancies.

  Parameters:
    `inObject` - CMetadata
  Returns:
    List of FQID Strings that were deleted.
  Throws:
    `MdException` - in the case of any server errors
    `java.rmi.RemoteException`

### deleteMetadataObject

    java.util.List<java.lang.String> deleteMetadataObject(java.lang.String objectType,
                                                          java.lang.String objectID)
                                                          throws MdException,
                                                                 java.rmi.RemoteException

  Deletes a metadata object and all of its dependencies

  Parameters:
    `objectType` - the metadata type
    `objectID` - the metadata object id
  Returns:
    list of object ids that were deleted
  Throws:
    `MdException`
    `java.rmi.RemoteException`

### deleteMetadataObject

    java.util.List<java.lang.String> deleteMetadataObject(java.lang.String objectType,
                                                          java.lang.String objectID,
                                                          java.lang.String template)
                                                          throws MdException,
                                                                 java.rmi.RemoteException

  Deletes a metadata object and all of its dependencies

  Parameters:
    `objectType` - the metadata type
    `objectID` - the metadata object id
    `template` - the template to process when deleting the public object
  Returns:
    list of object ids that were deleted
  Throws:
    `MdException`
    `java.rmi.RemoteException`

### deleteMetadataObjects

    java.util.List<java.lang.String> deleteMetadataObjects(java.util.List<? extends CMetadata> inObjects)
                                                           throws MdException,
                                                                  java.rmi.RemoteException

  Delete a CMetadata object and all it's dependancies.

  Parameters:
    `inObjects` - List
  Returns:
    List of FQID Strings that were deleted.
  Throws:
    `MdException` - in the case of any server errors
    `java.rmi.RemoteException`

### deleteMetadataObjects

    java.util.List<java.lang.String> deleteMetadataObjects(java.util.Map<java.lang.String,java.lang.String> inObjects)
                                                           throws MdException,
                                                                  java.rmi.RemoteException

  Delete multiple objects from the server and all their dependencies.

  Parameters:
    `inObjects` - Map of the items to be deleted. The keys of the map consist of the object ids and the values are the object types.
  Returns:
    List of FQID Strings that were deleted.
  Throws:
    `MdException` - in the case of any server errors
    `java.rmi.RemoteException`

### ApplyXML

    org.w3c.dom.Document ApplyXML(java.lang.String inXML,
                                  java.lang.String reposID)
                                  throws MdException,
                                         java.rmi.RemoteException

  This routine is used by metadata importers to filter their XML to handle XML updates.

  Parameters:
    `inXML` - String containing the XML inside of the tags
    `reposID` - ID of the repository to apply this change to
  Returns:
    org.w3c.dom.Document a document that contains the added XML returned from the server
  Throws:
    `MdException` - in the case of any server errors
    `java.rmi.RemoteException`

### getIdentity

    Identity getIdentity(MdObjectStore store)
                         throws MdException,
                                java.rmi.RemoteException

  This routine is used to retrieve the identity object of the current user.

  Parameters:
    `store` - Object Store associated with the metadata server for the current user.
  Returns:
    com.sas.metadata.remote.Identity that represents the current user
  Throws:
    `MdException`
    `java.rmi.RemoteException`

### getFoundationReposID

    java.lang.String getFoundationReposID()
                                          throws MdException,
                                                 java.rmi.RemoteException

  Returns the ID of the Foundation repository

  Returns:
    a string containing the ID
  Throws:
    `MdException`
    `java.rmi.RemoteException`

All Libraries | This Library | Package | Class | Use | Tree | Deprecated | Index | Grand Index | Help
|  | Metadata |
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2009 SAS Institute Inc. All Rights Reserved.